/*
Viral Loops v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package vloopapi

import (
	"encoding/json"
	"time"
)

// checks if the Milestone type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Milestone{}

// Milestone Viral loop milestone specifies the finish conditions and optional rewards for both referral and friend
type Milestone struct {
	Id string `json:"id"`
	ViralLoopId string `json:"viral_loop_id"`
	Name string `json:"name"`
	CompleteThreshold float32 `json:"complete_threshold"`
	ReferralRewardEach *RewardConfig `json:"referral_reward_each,omitempty"`
	ReferralRewardMilestoneCompleted *RewardConfig `json:"referral_reward_milestone_completed,omitempty"`
	FriendReward *RewardConfig `json:"friend_reward,omitempty"`
	Attributes *map[string]string `json:"attributes,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewMilestone instantiates a new Milestone object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMilestone(id string, viralLoopId string, name string, completeThreshold float32, createdAt time.Time, updatedAt time.Time) *Milestone {
	this := Milestone{}
	this.Id = id
	this.ViralLoopId = viralLoopId
	this.Name = name
	this.CompleteThreshold = completeThreshold
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewMilestoneWithDefaults instantiates a new Milestone object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMilestoneWithDefaults() *Milestone {
	this := Milestone{}
	return &this
}

// GetId returns the Id field value
func (o *Milestone) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Milestone) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Milestone) SetId(v string) {
	o.Id = v
}

// GetViralLoopId returns the ViralLoopId field value
func (o *Milestone) GetViralLoopId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ViralLoopId
}

// GetViralLoopIdOk returns a tuple with the ViralLoopId field value
// and a boolean to check if the value has been set.
func (o *Milestone) GetViralLoopIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ViralLoopId, true
}

// SetViralLoopId sets field value
func (o *Milestone) SetViralLoopId(v string) {
	o.ViralLoopId = v
}

// GetName returns the Name field value
func (o *Milestone) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Milestone) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Milestone) SetName(v string) {
	o.Name = v
}

// GetCompleteThreshold returns the CompleteThreshold field value
func (o *Milestone) GetCompleteThreshold() float32 {
	if o == nil {
		var ret float32
		return ret
	}

	return o.CompleteThreshold
}

// GetCompleteThresholdOk returns a tuple with the CompleteThreshold field value
// and a boolean to check if the value has been set.
func (o *Milestone) GetCompleteThresholdOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CompleteThreshold, true
}

// SetCompleteThreshold sets field value
func (o *Milestone) SetCompleteThreshold(v float32) {
	o.CompleteThreshold = v
}

// GetReferralRewardEach returns the ReferralRewardEach field value if set, zero value otherwise.
func (o *Milestone) GetReferralRewardEach() RewardConfig {
	if o == nil || IsNil(o.ReferralRewardEach) {
		var ret RewardConfig
		return ret
	}
	return *o.ReferralRewardEach
}

// GetReferralRewardEachOk returns a tuple with the ReferralRewardEach field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Milestone) GetReferralRewardEachOk() (*RewardConfig, bool) {
	if o == nil || IsNil(o.ReferralRewardEach) {
		return nil, false
	}
	return o.ReferralRewardEach, true
}

// HasReferralRewardEach returns a boolean if a field has been set.
func (o *Milestone) HasReferralRewardEach() bool {
	if o != nil && !IsNil(o.ReferralRewardEach) {
		return true
	}

	return false
}

// SetReferralRewardEach gets a reference to the given RewardConfig and assigns it to the ReferralRewardEach field.
func (o *Milestone) SetReferralRewardEach(v RewardConfig) {
	o.ReferralRewardEach = &v
}

// GetReferralRewardMilestoneCompleted returns the ReferralRewardMilestoneCompleted field value if set, zero value otherwise.
func (o *Milestone) GetReferralRewardMilestoneCompleted() RewardConfig {
	if o == nil || IsNil(o.ReferralRewardMilestoneCompleted) {
		var ret RewardConfig
		return ret
	}
	return *o.ReferralRewardMilestoneCompleted
}

// GetReferralRewardMilestoneCompletedOk returns a tuple with the ReferralRewardMilestoneCompleted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Milestone) GetReferralRewardMilestoneCompletedOk() (*RewardConfig, bool) {
	if o == nil || IsNil(o.ReferralRewardMilestoneCompleted) {
		return nil, false
	}
	return o.ReferralRewardMilestoneCompleted, true
}

// HasReferralRewardMilestoneCompleted returns a boolean if a field has been set.
func (o *Milestone) HasReferralRewardMilestoneCompleted() bool {
	if o != nil && !IsNil(o.ReferralRewardMilestoneCompleted) {
		return true
	}

	return false
}

// SetReferralRewardMilestoneCompleted gets a reference to the given RewardConfig and assigns it to the ReferralRewardMilestoneCompleted field.
func (o *Milestone) SetReferralRewardMilestoneCompleted(v RewardConfig) {
	o.ReferralRewardMilestoneCompleted = &v
}

// GetFriendReward returns the FriendReward field value if set, zero value otherwise.
func (o *Milestone) GetFriendReward() RewardConfig {
	if o == nil || IsNil(o.FriendReward) {
		var ret RewardConfig
		return ret
	}
	return *o.FriendReward
}

// GetFriendRewardOk returns a tuple with the FriendReward field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Milestone) GetFriendRewardOk() (*RewardConfig, bool) {
	if o == nil || IsNil(o.FriendReward) {
		return nil, false
	}
	return o.FriendReward, true
}

// HasFriendReward returns a boolean if a field has been set.
func (o *Milestone) HasFriendReward() bool {
	if o != nil && !IsNil(o.FriendReward) {
		return true
	}

	return false
}

// SetFriendReward gets a reference to the given RewardConfig and assigns it to the FriendReward field.
func (o *Milestone) SetFriendReward(v RewardConfig) {
	o.FriendReward = &v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *Milestone) GetAttributes() map[string]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Milestone) GetAttributesOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *Milestone) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]string and assigns it to the Attributes field.
func (o *Milestone) SetAttributes(v map[string]string) {
	o.Attributes = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Milestone) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Milestone) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Milestone) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Milestone) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Milestone) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Milestone) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o Milestone) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Milestone) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["viral_loop_id"] = o.ViralLoopId
	toSerialize["name"] = o.Name
	toSerialize["complete_threshold"] = o.CompleteThreshold
	if !IsNil(o.ReferralRewardEach) {
		toSerialize["referral_reward_each"] = o.ReferralRewardEach
	}
	if !IsNil(o.ReferralRewardMilestoneCompleted) {
		toSerialize["referral_reward_milestone_completed"] = o.ReferralRewardMilestoneCompleted
	}
	if !IsNil(o.FriendReward) {
		toSerialize["friend_reward"] = o.FriendReward
	}
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableMilestone struct {
	value *Milestone
	isSet bool
}

func (v NullableMilestone) Get() *Milestone {
	return v.value
}

func (v *NullableMilestone) Set(val *Milestone) {
	v.value = val
	v.isSet = true
}

func (v NullableMilestone) IsSet() bool {
	return v.isSet
}

func (v *NullableMilestone) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMilestone(val *Milestone) *NullableMilestone {
	return &NullableMilestone{value: val, isSet: true}
}

func (v NullableMilestone) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMilestone) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


